/**
 * Yum Food Orders
 * **Yum application, order food daily from the best chef in town**  This API is used by the angular.io client, and is not meant to be used otherwise.  Find source code of this API [here](http://gitlab/)  Copyright (C) 2017 JR Technologies. 
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class ChefApi {
    protected basePath = 'http://localhost:8082/api';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * update the daily menu with the given id
     * updates the foods of a daily menu with the specified id.
     * @param id The daily menu&#39;s unique id.
     * @param updateDailyMenu The updated list of foods.
     */
    public dailyMenusIdPut(id: number, updateDailyMenu: models.UpdateDailyMenu, extraHttpRequestParams?: any): Observable<models.DailyMenuChef> {
        return this.dailyMenusIdPutWithHttpInfo(id, updateDailyMenu, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Gets the current month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with current month&#39;s concerned weeks dailyMenus and orders.
     */
    public dailyMenusMonthlyGet(extraHttpRequestParams?: any): Observable<models.DailyMenusChef> {
        return this.dailyMenusMonthlyGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Gets requested month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with the requested month&#39;s concerned weeks dailyMenus and orders.
     * @param monthYear The requested month-Year in format MM-YYYY.
     */
    public dailyMenusMonthlyMonthYearGet(monthYear: string, extraHttpRequestParams?: any): Observable<models.DailyMenusChef> {
        return this.dailyMenusMonthlyMonthYearGetWithHttpInfo(monthYear, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Creates a new daily menu.
     * Adds a new daily menu with the given characteristics.
     * @param foodList The list of foods.
     */
    public dailyMenusPost(foodList?: models.FoodList, extraHttpRequestParams?: any): Observable<models.DailyMenuChef> {
        return this.dailyMenusPostWithHttpInfo(foodList, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Find a food by its name.
     * Returns a food with the given name.
     * @param name The name of the requested food.
     */
    public foodsFindByNameNameGet(name: string, extraHttpRequestParams?: any): Observable<models.FoodItem> {
        return this.foodsFindByNameNameGetWithHttpInfo(name, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Gets all foods.
     * Returns a list of all the foods.
     * @param version A string to describe the client&#39;s foods version.
     * @param archived A boolean to describe if the client requests the archived foods.
     * @param type A string to describe the filtering.
     * @param sort A string to describe the sorting preference.
     * @param page An integer to describe the requested page.
     * @param size An integer to describe the number of foods to retrieve.
     */
    public foodsGet(version?: number, archived?: boolean, type?: string, sort?: string, page?: number, size?: number, extraHttpRequestParams?: any): Observable<models.FoodItems> {
        return this.foodsGetWithHttpInfo(version, archived, type, sort, page, size, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Delete or archive the food with the given id.
     * Delete or archive a food by its id.
     * @param id The food&#39;s unique id.
     * @param archived A boolean to describe if the Food object has to be archived.
     */
    public foodsIdDelete(id: number, archived?: boolean, extraHttpRequestParams?: any): Observable<{}> {
        return this.foodsIdDeleteWithHttpInfo(id, archived, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Checks if a food is editable.
     * Gets the food_id and checks if it can be edited.
     * @param id The food&#39;s unique id
     * @param editable A boolean to describe if the Food object is editable.
     */
    public foodsIdGet(id: number, editable?: boolean, extraHttpRequestParams?: any): Observable<models.FoodItemEditable> {
        return this.foodsIdGetWithHttpInfo(id, editable, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Updates the food with the given id
     * Updates the fields of a food object with the specified id.
     * @param id The food&#39;s unique id.
     * @param updateFoodDetails The updated fields of the selected food object.
     * @param clone A boolean to describe if the Food object has to be cloned.
     */
    public foodsIdPut(id: number, updateFoodDetails: models.UpdateFoodDetails, clone?: boolean, extraHttpRequestParams?: any): Observable<models.Version> {
        return this.foodsIdPutWithHttpInfo(id, updateFoodDetails, clone, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Adds a new food to the system.
     * Adds a new food to the system with the given characteristics.
     * @param foodDetails The food to create.
     */
    public foodsPost(foodDetails?: models.FoodDetails, extraHttpRequestParams?: any): Observable<{}> {
        return this.foodsPostWithHttpInfo(foodDetails, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Gets the current days&#39;s orders.
     * Returns the current days&#39;s orders.
     * @param day The requested day.
     */
    public ordersDailyDayGet(day: string, extraHttpRequestParams?: any): Observable<models.DailyOrders> {
        return this.ordersDailyDayGetWithHttpInfo(day, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Gets the current month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with current month&#39;s concerned weeks dailyMenus and orders.
     */
    public ordersMonthlyGet(extraHttpRequestParams?: any): Observable<models.DailyOrdersChef> {
        return this.ordersMonthlyGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Gets requested month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with the requested month&#39;s concerned weeks dailyMenus and orders.
     * @param monthYear The requested month-Year in format MM-YYYY.
     */
    public ordersMonthlyMonthYearGet(monthYear: string, extraHttpRequestParams?: any): Observable<models.DailyOrdersChef> {
        return this.ordersMonthlyMonthYearGetWithHttpInfo(monthYear, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * update the daily menu with the given id
     * updates the foods of a daily menu with the specified id.
     * @param id The daily menu&#39;s unique id.
     * @param updateDailyMenu The updated list of foods.
     */
    public dailyMenusIdPutWithHttpInfo(id: number, updateDailyMenu: models.UpdateDailyMenu, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling dailyMenusIdPut.');
        }
        // verify required parameter 'updateDailyMenu' is not null or undefined
        if (updateDailyMenu === null || updateDailyMenu === undefined) {
            throw new Error('Required parameter updateDailyMenu was null or undefined when calling dailyMenusIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: updateDailyMenu == null ? '' : JSON.stringify(updateDailyMenu), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Gets the current month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with current month&#39;s concerned weeks dailyMenus and orders.
     */
    public dailyMenusMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus/monthly`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Gets requested month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with the requested month&#39;s concerned weeks dailyMenus and orders.
     * @param monthYear The requested month-Year in format MM-YYYY.
     */
    public dailyMenusMonthlyMonthYearGetWithHttpInfo(monthYear: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus/monthly/${monthYear}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'monthYear' is not null or undefined
        if (monthYear === null || monthYear === undefined) {
            throw new Error('Required parameter monthYear was null or undefined when calling dailyMenusMonthlyMonthYearGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Creates a new daily menu.
     * Adds a new daily menu with the given characteristics.
     * @param foodList The list of foods.
     */
    public dailyMenusPostWithHttpInfo(foodList?: models.FoodList, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/dailyMenus`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: foodList == null ? '' : JSON.stringify(foodList), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Find a food by its name.
     * Returns a food with the given name.
     * @param name The name of the requested food.
     */
    public foodsFindByNameNameGetWithHttpInfo(name: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/findByName/${name}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'name' is not null or undefined
        if (name === null || name === undefined) {
            throw new Error('Required parameter name was null or undefined when calling foodsFindByNameNameGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Gets all foods.
     * Returns a list of all the foods.
     * @param version A string to describe the client&#39;s foods version.
     * @param archived A boolean to describe if the client requests the archived foods.
     * @param type A string to describe the filtering.
     * @param sort A string to describe the sorting preference.
     * @param page An integer to describe the requested page.
     * @param size An integer to describe the number of foods to retrieve.
     */
    public foodsGetWithHttpInfo(version?: number, archived?: boolean, type?: string, sort?: string, page?: number, size?: number, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        if (version !== undefined) {
            queryParameters.set('version', <any>version);
        }

        if (archived !== undefined) {
            queryParameters.set('archived', <any>archived);
        }

        if (type !== undefined) {
            queryParameters.set('type', <any>type);
        }

        if (sort !== undefined) {
            queryParameters.set('sort', <any>sort);
        }

        if (page !== undefined) {
            queryParameters.set('page', <any>page);
        }

        if (size !== undefined) {
            queryParameters.set('size', <any>size);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Delete or archive the food with the given id.
     * Delete or archive a food by its id.
     * @param id The food&#39;s unique id.
     * @param archived A boolean to describe if the Food object has to be archived.
     */
    public foodsIdDeleteWithHttpInfo(id: number, archived?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling foodsIdDelete.');
        }
        if (archived !== undefined) {
            queryParameters.set('archived', <any>archived);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Checks if a food is editable.
     * Gets the food_id and checks if it can be edited.
     * @param id The food&#39;s unique id
     * @param editable A boolean to describe if the Food object is editable.
     */
    public foodsIdGetWithHttpInfo(id: number, editable?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling foodsIdGet.');
        }
        if (editable !== undefined) {
            queryParameters.set('editable', <any>editable);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Updates the food with the given id
     * Updates the fields of a food object with the specified id.
     * @param id The food&#39;s unique id.
     * @param updateFoodDetails The updated fields of the selected food object.
     * @param clone A boolean to describe if the Food object has to be cloned.
     */
    public foodsIdPutWithHttpInfo(id: number, updateFoodDetails: models.UpdateFoodDetails, clone?: boolean, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods/${id}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'id' is not null or undefined
        if (id === null || id === undefined) {
            throw new Error('Required parameter id was null or undefined when calling foodsIdPut.');
        }
        // verify required parameter 'updateFoodDetails' is not null or undefined
        if (updateFoodDetails === null || updateFoodDetails === undefined) {
            throw new Error('Required parameter updateFoodDetails was null or undefined when calling foodsIdPut.');
        }
        if (clone !== undefined) {
            queryParameters.set('clone', <any>clone);
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: updateFoodDetails == null ? '' : JSON.stringify(updateFoodDetails), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Adds a new food to the system.
     * Adds a new food to the system with the given characteristics.
     * @param foodDetails The food to create.
     */
    public foodsPostWithHttpInfo(foodDetails?: models.FoodDetails, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/foods`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Post,
            headers: headers,
            body: foodDetails == null ? '' : JSON.stringify(foodDetails), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Gets the current days&#39;s orders.
     * Returns the current days&#39;s orders.
     * @param day The requested day.
     */
    public ordersDailyDayGetWithHttpInfo(day: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/daily/${day}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'day' is not null or undefined
        if (day === null || day === undefined) {
            throw new Error('Required parameter day was null or undefined when calling ordersDailyDayGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Gets the current month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with current month&#39;s concerned weeks dailyMenus and orders.
     */
    public ordersMonthlyGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/monthly`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Gets requested month&#39;s concerned weeks dailyMenus and order history.
     * Returns a list with the requested month&#39;s concerned weeks dailyMenus and orders.
     * @param monthYear The requested month-Year in format MM-YYYY.
     */
    public ordersMonthlyMonthYearGetWithHttpInfo(monthYear: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/orders/monthly/${monthYear}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'monthYear' is not null or undefined
        if (monthYear === null || monthYear === undefined) {
            throw new Error('Required parameter monthYear was null or undefined when calling ordersMonthlyMonthYearGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        // authentication (Bearer) required
        if (this.configuration.apiKey) {
            headers.set('Authorization', this.configuration.apiKey);
        }

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
